function delta_a2=geom_be_error(p,E,G)


n=length(p)-1;
pm=p/p(n+1);
A=[[zeros(1,n-1);eye(n-1)],-p(1:n).'];
B=eye(n); B(n,n)=p(n+1); % companion pencil
C=A/B; % companion matrix

traceE=zeros(n+1,1);
traceG=zeros(n+1,1);


%pm=p/p(n+1);
delta_a=zeros(n+1,1);
delta_a(n+1)=p(n+1)*trace(B\G);
M_old=eye(n);
for k=n:-1:1
    %M_new=C*M_old+pm(k)*eye(n);
    M_new=M_old*C+pm(k)*eye(n);
    delta_a(k)=p(n+1)*(-trace(B\M_old*E)+trace(B\M_new*G));
    traceE(k)=p(n+1)*trace(B\M_old*E);
    traceG(k)=p(n+1)*trace(B\M_new*G);
    %delta_a(k)=-trace(M_old*(B\E))+trace(M_new*(B\G));
    %delta_a(k)=trace(B\M_old*E)+trace(B\M_new*G);
    M_old=M_new;
end


% let us check with formula (6.10)
delta_a2=zeros(n+1,1);
delta_a2(n+1)=p(n+1)*trace(B\G);
for k=1:n
    sE1=0;
    for m=0:k-1
        sE2=0;
        for j=k+1:n
            sE2=sE2+E(j,j+m-k);
        end
        sE1=sE1+p(m+1)*sE2;
    end
    sE3=0;
    for m=k:n
        sE4=0;
        for j=1:k
            sE4=sE4+E(j,j+m-k);
        end
        sE3=sE3+p(m+1)*sE4;
    end
    
    sG1=0;
    for m=0:k-2
        sG2=0;
        for j=k:n
            sG2=sG2+G(j,j+m-k+1);
        end
        sG1=sG1+p(m+1)*sG2;
    end
    sG3=0;
    for m=k-1:n
        sG4=0;
        for j=1:k-1
            sG4=sG4+G(j,j+m-k+1);
        end
        sG3=sG3+p(m+1)*sG4;
    end
    if k==1
        delta_a2(k)=sE1-sE3+(p(n+1)-1)*E(k,n);
    else
        delta_a2(k)=sE1-sE3+(p(n+1)-1)*E(k,n)-sG1+sG3-(p(n+1)-1)*G(k-1,n);
    end
end