function [H,y]=hh3(x)

% for x column vector of length 3,
% computes a unitary H such that H*x has the
% second and third entries equal to zero

[H1,y1]=planerot(x(2:3));
x=[x(1); y1];
[H2,y]=planerot(x(1:2));
H1=[1 0 0; zeros(2,1) H1];
H2=[H2 zeros(2,1); 0 0 1];
H=H2*H1;